#include <bits/stdc++.h>
using namespace std;


struct DSU {
    int n;
    vector<int> par, sz;

    DSU(int m) {
        n = m;
        par.assign(n + 1, 0);
        sz.assign(n + 1, 1);

        for (int i = 0; i <= n; i++) {
            par[i] = i;
        }
    }

    int findSet(int node) {
        if (par[node] == node) {
            return node;
        }
        return par[node] = findSet(par[node]);
    }

    void unionSets(int a, int b) {
        a = findSet(a);
        b = findSet(b);

        if (a == b) return;
        if (sz[a] > sz[b]) swap(a, b);
        sz[b] += sz[a];
        par[a] = b;
    }
};

int n, m;

int conv(int i, int j) {
    return i * (m + 2) + j;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;

    int a[n + 2][m + 2] = {};
    for (int i = 1; i <= n; i++) {
        for (int j = 1; j <= m; j++) {
            cin >> a[i][j];
        }
    }

    int ldp[m + 1];
    ldp[0] = 0;

    DSU dsu = DSU((n + 2) * (m + 2) + 10);

    for (int j = 1; j <= m; j++) {
        ldp[j] = ldp[j - 1];
        for (int i = 1; i <= n; i++) {
            if (a[i][j] != a[i][j - 1] && a[i][j] != a[i - 1][j]) {
                ldp[j]++;
            }
            else if (a[i][j] == a[i][j - 1] && a[i][j] == a[i - 1][j]) {
                int hereleft = dsu.findSet(conv(i, j - 1));
                int hereup = dsu.findSet(conv(i - 1, j));
                if (hereup != hereleft) {
                    ldp[j]--;
                }
                dsu.unionSets(conv(i, j), conv(i - 1, j));
                dsu.unionSets(conv(i, j), conv(i, j - 1));
            }
            else if (a[i][j] == a[i][j - 1]) {
                dsu.unionSets(conv(i, j), conv(i, j - 1));
            }
            else if (a[i][j] == a[i - 1][j]) {
                dsu.unionSets(conv(i, j), conv(i - 1, j));
            }
        }
    }


    int rdp[m + 2] = {};
    rdp[m + 1] = 0;
    
    dsu = DSU((n + 2) * (m + 2) + 10);
    for (int j = m; j >= 1; j--) {
        rdp[j] = rdp[j + 1];
        for (int i = 1; i <= n; i++) {
            if (a[i][j] != a[i - 1][j] && a[i][j] != a[i][j + 1]) {
                rdp[j]++;
            }
            else if (a[i][j] == a[i - 1][j] && a[i][j] == a[i][j + 1]) {
                int hereright = dsu.findSet(conv(i, j + 1));
                int hereup = dsu.findSet(conv(i - 1, j));
                if (hereup != hereright) {
                    rdp[j]--;
                }
                dsu.unionSets(conv(i, j), conv(i - 1, j));
                dsu.unionSets(conv(i, j), conv(i, j + 1));
            }
            else if (a[i][j] == a[i - 1][j]) {
                dsu.unionSets(conv(i, j), conv(i - 1, j));
            }
            else if (a[i][j] == a[i][j + 1]) {
                dsu.unionSets(conv(i, j), conv(i, j + 1));
            }
        }
    }

    int ans = INT_MAX;
    for (int j = 1; j < m; j++) {
        ans = min(ans, ldp[j] + rdp[j + 1]);
    }

    printf("%i\n", ans);
}
