#include <bits/stdc++.h>
using namespace std;
using ll = long long;

constexpr ll INF = 1000000000000000000LL;

ll n, m, q, k, x, y, a, b, c;

struct dsu {
    vector<ll> par;
    vector<ll> sz;
    ll comp;

    dsu(ll N) {
        par.resize(N);
        sz.resize(N);
        for (int i = 0; i < N; i++) {
            par[i] = i;
            sz[i] = 1;
        }
        comp = N;
    }

    ll find_p(ll x) {
        if (par[x] == x) {
            return x;
        }
        ll p = find_p(par[x]);
        par[x] = p;
        return p;
    }

    void join(ll x, ll y) {
        x = find_p(x);
        y = find_p(y);
        if (x == y) {
            return;
        }
        comp--;
        if (sz[y] > sz[x]) {
            swap(x, y);
        }
        sz[x] += sz[y];
        par[y] = x;
    }
};

ll hsh(ll x, ll y) {
    return x * m + y;
}

vector<ll> fun(vector< vector<ll> > &v) {
    vector<ll> ans(m);
    dsu d(n * m);
    for (int j = 0; j < m; j++) {
        for (int i = 0; i < n; i++) {
            if (j > 0 && v[i][j - 1] == v[i][j]) {
                d.join(hsh(i, j), hsh(i, j - 1));
            }
        }
        for (int i = 0; i < n - 1; i++) {
            if (v[i + 1][j] == v[i][j]) {
                d.join(hsh(i, j), hsh(i + 1, j));
            }
        }
        ans[j] = d.comp - ((m - 1 - j) * n);
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    vector< vector<ll> > v(n, vector<ll>(m));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }
    vector<ll> pr = fun(v);
    for (int i = 0; i < n; i++) {
        reverse(v[i].begin(), v[i].end());
    }
    vector<ll> su = fun(v);
    reverse(su.begin(), su.end());
    ll ans = INF;
    for (int i = 0; i < m - 1; i++) {
        ans = min(ans, pr[i] + su[i + 1]);
    }
    cout << ans << '\n';
}
