#include <iostream>
#include <vector>

using namespace std;

int* answers;
Object* objects;

enum ObjectType {
    BELL = 0,
    HOUSE = 1
};

struct Object {
public:
    int coord;
    ObjectType type;
    int index;
};

class ObjectComparator {
public:
    bool operator()(const Object& a, const Object& b) {
        return a.coord < b.coord;
    }
};

int main() {
    int bells_count, houses_count, volume;
    cin >> bells_count >> houses_count >> volume;

    answers = new int[houses_count];
    objects = new Object[bells_count + houses_count];

    for (int i = 0; i < bells_count; i++) {
        cin >> objects[i].coord;
        objects[i].type = BELL;
        objects[i].index = i;
    }

    for (int i = 0; i < houses_count; i++) {
        cin >> objects[i].coord;
        objects[i].type = HOUSE;
        objects[i].index = i;
    }

    sort(objects, objects + bells_count + houses_count);

    int prev_bell_coord = -1;
    int next_bell_coord = -1;
    int have_no_next_bell = false;

    for (int i = 0; i < bells_count + houses_count; i++) {
        Object& obj = objects[i];

        if (obj.type == BELL) {
            prev_bell_coord = obj.coord;
            next_bell_coord = -1;
        } else if (obj.type == HOUSE) {
            int max_sound = 0;

            if (prev_bell_coord != -1) {
                max_sound = max(volume - (obj.coord - prev_bell_coord), 0);
            }

            if (have_no_next_bell) {
                answers[obj.index] = max_sound;
                continue;
            }

            if (next_bell_coord == -1) {
                for (int j = i + 1; j < bells_count + houses_count; j++) {
                    if (objects[j].type == BELL) {
                        next_bell_coord = objects[j].coord;
                        break;
                    }
                }
            }

            if (next_bell_coord == -1) {
                have_no_next_bell = true;
            } else {
                max_sound = max(max_sound, max(volume - (next_bell_coord - obj.coord), 0));
            }

            answers[obj.index] = max_sound;
        }
    }

    for (int i = 0; i < houses_count; i++) {
        cout << answers[i] << "\n";
    }

    return 0;
}
