#include <iostream>
#include <climits>

using namespace std;

#define MINUS_INF INT_MIN

int main() {
    int height, width;
    cin >> height >> width;

    char** matrix = new char*[height];
    int* row_counts = new int[height];
    int* column_counts = new int[width];

    memset(row_counts, 0, height * sizeof(int));
    memset(column_counts, 0, width * sizeof(int));

    int first_max_column = 0;
    int second_max_column = 0;
    int first_max_column_x = 0;
    int second_max_column_x = 0;

    int alice_count = 0;
    int bob_count = 0;

    for (int y = 0; y < height; y++) {
        matrix[y] = new char[width];

        for (int x = 0; x < width; x++) {
            char c;
            cin >> c;

            matrix[y][x] = c;

            if (c == '#') {
                column_counts[x] += 1;
                alice_count += 1;

                // if (column_counts[x] > first_max_column) {
                //     second_max_column = first_max_column;
                //     first_max_column = column_counts[x];
                //     second_max_column_x = first_max_column_x;
                //     first_max_column_x = x;
                // } else if (column_counts[x] > second_max_column) {
                //     second_max_column = column_counts[x];
                //     second_max_column_x = x;
                // }
            } else {
                row_counts[y] += 1;
                bob_count += 1;
            }
        }
    }

    int max_alice_delta = MINUS_INF;

    for (int y = 0; y < height; y++) {
        int gain = row_counts[y] * 2 - width;
        // int first_max_change = matrix[y][first_max_column_x] == '.' ? 1 : -1;
        // int second_max_change = matrix[y][second_max_column_x] == '.' ? 1 : -1;
        // int loss = max(first_max_column + first_max_change, second_max_column + second_max_change);
        int max_loss = MINUS_INF;

        for (int x = 0; x < width; x++) {
            int change = matrix[y][x] == '.' ? 1 : -1;
            int new_col_count = column_counts[x] + change;
            // cout << new_col_count << "\n";
            int loss = new_col_count * 2 - height;

            if (loss > max_loss) {
                max_loss = loss;
            }
        }

        int delta = gain - max_loss;
        // cout << gain << " " << max_loss << "\n";

        if (delta > max_alice_delta) {
            max_alice_delta = delta;
        }
    }

    cout << (alice_count + max_alice_delta) << " " << (bob_count - max_alice_delta) << "\n";

    return 0;
}
