#include <iostream>
#include <vector>
#include <map>
#include <climits>

using namespace std;

int main() {
    int height, width;
    cin >> height >> width;

    int** heightmap = new int*[height];
    int** components_l = new int*[height];
    int** components_r = new int*[height];

    map<int, int> normalized_heights{};
    int next_normalized = 0;

    int** connected_components_l = new int*[width - 1];
    int** connected_components_r = new int*[width - 1];

    for (int i = 0; i < height; i++) {
        heightmap[i] = new int[width];
        components_l[i] = new int[width];
        components_r[i] = new int[width];

        for (int j = 0; j < width; j++) {
            int h;
            cin >> h;

            if (normalized_heights.find(h) == normalized_heights.end()) {
                normalized_heights[h] = next_normalized++;
            }

            heightmap[i][j] = normalized_heights[h];
        }
    }

    int next_component_l = 0;
    int next_component_r = 0;

    // cout << "1\n";

    for (int j = 0; j < width - 1; j++) {
        connected_components_l[j] = new int[next_normalized];
            if (j > 0) {
                for (int k = 0; k < next_normalized; k++) {
                connected_components_l[j][k] = connected_components_l[j - 1][k];
                }
            }

        for (int i = 0; i < height; i++) {
            bool same_as_up = i > 0 && heightmap[i][j] == heightmap[i - 1][j];
            bool same_as_left = j > 0 && heightmap[i][j] == heightmap[i][j - 1];

            if (same_as_up) {
                components_l[i][j] = components_l[i - 1][j];

                if (same_as_left && components_l[i][j] != components_l[i][j - 1]) {
                    connected_components_l[j][heightmap[i][j]] -= 1;
                }
            } else if (same_as_left) {
                components_l[i][j] = components_l[i][j - 1];
            } else {
                components_l[i][j] = next_component_l++;
                connected_components_l[j][heightmap[i][j]] += 1;
            }
        }
    }

    // cout << "2\n";
    for (int j = width - 1; j > 0; j--) {
        connected_components_r[j] = new int[next_normalized];
            if (j < width - 1) {
                for (int k = 0; k < next_normalized; k++) {
                connected_components_r[j][k] = connected_components_r[j + 1][k];
                }
            }

        for (int i = 0; i < height; i++) {
            bool same_as_up = i > 0 && heightmap[i][j] == heightmap[i - 1][j];
            bool same_as_right = j < width - 1 && heightmap[i][j] == heightmap[i][j + 1];

            if (same_as_up) {
                components_r[i][j] = components_r[i - 1][j];

                if (same_as_right && components_r[i][j] != components_r[i][j + 1]) {
                    connected_components_r[j][heightmap[i][j]] -= 1;
                }
            } else if (same_as_right) {
                components_r[i][j] = components_r[i][j + 1];
            } else {
                components_r[i][j] = next_component_r++;
                connected_components_r[j][heightmap[i][j]] += 1;
                // if (heightmap[i][j] == 0) {
                //     cout << connected_components_r[j][heightmap[i][j]] << "\n";
                // }
            }
        }
    }

    int min = INT_MAX;

    for (int i = 0; i < width - 1; i++) {
        int curr = 0;

        for (int j = 0; j < next_normalized; j++) {
            curr += connected_components_l[i][j];
            curr += connected_components_r[i+1][j];
        }

        if (curr < min) {
            min = curr;
        }
    }

    cout << min << "\n";

    // for (int i = 0; i < next_normalized; i++) {
    //     cout << i << ": ";

    //     for (int j = 0; j < width - 1; j++) {
    //         cout << connected_components_l[j][i] << " ";
    //     }

    //     cout << "\n";
    // }

    // cout << "\n";

    // for (int i = 0; i < next_normalized; i++) {
    //     cout << i << ": ";

    //     for (int j = 1; j <= width - 1; j++) {
    //         cout << connected_components_r[j][i] << " ";
    //     }

    //     cout << "\n";
    // }

    return 0;
}
